#define SaveContext         portDISABLE_INTERRUPTS() \
                asm MOVFF        TABLAT, PREINC1; \
                asm MOVFF        TBLPTRU, PREINC1; \
                asm MOVFF        TBLPTRH, PREINC1; \
                asm MOVFF        TBLPTRL, PREINC1; \
                asm MOVFF        PRODH, PREINC1; \
                asm MOVFF        PRODL, PREINC1; \
                asm MOVFF        PCLATU, PREINC1; \
                asm MOVFF        PCLATH, PREINC1; \
                asm CLRF        FSR0L, 0; \
                asm CLRF        FSR0H, 0; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        POSTINC0, PREINC1; \
                asm MOVFF        INDF0, PREINC1; \
                asm MOVFF        FSR0L, PREINC1; \
                asm MOVFF        FSR0H, PREINC1; \
                asm MOVFF        STKPTR, FSR0L; \
                while( STKPTR > ( unsigned portCHAR ) 0 ) \
                {                                         \
                        asm MOVFF        TOSL, PREINC1;   \
                        asm MOVFF        TOSH, PREINC1;   \
                        asm MOVFF        TOSU, PREINC1;   \
                        asm POP;                          \
                } \
                asm MOVFF        FSR0L, PREINC1; \
                asm MOVF        PREINC1, 1, 0; \
                asm MOVFF        _ActiveTask, FSR0L; \
                asm MOVFF        _ActiveTask + 1, FSR0H; \
                asm MOVFF        FSR1L, POSTINC0; \
                asm MOVFF        FSR1H, POSTINC0;


#define RestoreContext        portDISABLE_INTERRUPTS() \
                asm MOVFF        _ActiveTask, FSR0L; \
                asm MOVFF        _ActiveTask+1, FSR0H; \
                asm MOVFF        POSTINC0, FSR1L; \
                asm MOVFF        POSTINC0, FSR1H; \
                asm MOVFF        POSTDEC1, FSR0L; \
                asm MOVFF        POSTDEC1, FSR0L; \
                STKPTR = 0; \
               while( STKPTR < FSR0L )              \
               {                                    \
                        asm PUSH;                        \
                        asm MOVF        POSTDEC1, 0, 0;  \
                        asm MOVWF        TOSU, 0;        \
                        asm MOVF        POSTDEC1, 0, 0;  \
                        asm MOVWF        TOSH, 0;        \
                        asm MOVF        POSTDEC1, 0, 0;  \
                        asm MOVWF        TOSL, 0;        \
                } \
                asm MOVFF        POSTDEC1, FSR0H; \
                asm MOVFF        POSTDEC1, FSR0L; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, POSTDEC0; \
                asm MOVFF        POSTDEC1, INDF0; \
                asm MOVFF        POSTDEC1, PCLATH; \
                asm MOVFF        POSTDEC1, PCLATU; \
                asm MOVFF        POSTDEC1, PRODL; \
                asm MOVFF        POSTDEC1, PRODH; \
                asm MOVFF        POSTDEC1, TBLPTRL; \
                asm MOVFF        POSTDEC1, TBLPTRH; \
                asm MOVFF        POSTDEC1, TBLPTRU; \
                asm MOVFF        POSTDEC1, TABLAT; \
                asm RETFIE        0;